Reconstruct Itinerary | Leetcode

  Рет қаралды 33,885

Techdose

Techdose

Күн бұрын

This video explains an important graph programming interview problem which is to reconstruct itinerary.This problem can be solved by using just simple graph traversal technique by using multiset and stack.Map is used to construct the adjacency list because we need random access by string value.Multiset is used to keep the values sorted in ascending order.Stack is used to handle the route exceptions.I have explained the entire problem step by step by using proper examples and intuition for each step.I have dry run the algorithm and have also explained the code walk through at the end of the video.CODE LINK is present below as usual. If you find any difficulty or have any query then do COMMENT below. PLEASE help our channel by SUBSCRIBING and LIKE our video if you found it helpful...CYA :)
=================================================================
INSTAGRAM: / surya.pratap.k
LinkedIn: / surya-pratap-kahar-47b...
WEBSITE: techdose.co.in/
=================================================================
CODE LINK: gist.github.co...
USEFUL LINKs:-
Representation of graph using adjacency matrix and adjacency list: • Representation of grap...
DFS: • Depth first search | D...
BFS: • Breadth first search |...

Пікірлер: 156
@subham-raj
@subham-raj 4 жыл бұрын
How can this be O(E)? How can the removal of edge from the adjacency list (sorted by value) be O(1)?
@techdose4u
@techdose4u 4 жыл бұрын
Insertion & Deletion is logN in a multiset.So,if you consider all the insertions and deletions, it will be O(ElogE).
@vineetsharma4635
@vineetsharma4635 4 жыл бұрын
Amortized complexity is O(1) and worst case complexity is O(log(size_of_ds))
@techdose4u
@techdose4u 4 жыл бұрын
Yea correct.
@dhruvbhanderi3407
@dhruvbhanderi3407 2 жыл бұрын
you can use priority queue instead of multiset .if you use priority queue then you are removed first element which is O(N)
@parekshamanchanda8083
@parekshamanchanda8083 4 жыл бұрын
This stack DS in this problem was really not intuitive. Good one!
@techdose4u
@techdose4u 4 жыл бұрын
Thanks
@coreyladovsky1501
@coreyladovsky1501 4 жыл бұрын
Your videos are so good! I love the way you break down problems and give such clear concise answers. Thank you so much!
@techdose4u
@techdose4u 4 жыл бұрын
Welcome :)
@yuhaokong
@yuhaokong 4 жыл бұрын
Love the thought process when using a stack
@techdose4u
@techdose4u 4 жыл бұрын
😀
@SameerSrinivas
@SameerSrinivas 4 жыл бұрын
Thanks for explaining. It helps immensely if you can also talk about intuition behind why the chosen logic would work. Cheers!
@AnshulSharma-vw9wu
@AnshulSharma-vw9wu 4 жыл бұрын
HI @Techdose I am a Java developer , so most of the times , i don't understand fully your C++ code , but i liked your thought process , so whenever i stuck , i came to your channel , i am preparing for my upcoming interview . This problem seems to be tricky DFS ( Post order Traversal problem ) . /** [ ["JFK","SFO"], ["JFK","ATL"], ["SFO","ATL"], ["ATL","JFK"], ["ATL","SFO"] ] JFK= [SFO,ATL] , SFO=[ATL] ,ATL =[JFK,SFO] 1. Prepare the adjList = JFK= [SFO,ATL] , SFO=[ATL] ,ATL =[JFK,SFO]. 2. Then do DFS for each neighbours . Only trick is do Post order where neighbours goes first and then actual Node. 3. Since the answer is in reverse Order . Then reverse at last. NOTE : I have used PriorityQueue for maintaining sorted order in Adjacency list. dfs Iteration Answer start = JFK answer [SFO,ATL,SFO,JFK, ATL,JFK] ATL answer [SFO,ATL,SFO,JFK, ATL] JFK answer [SFO,ATL,SFO,JFK] SFO answer [SFO,ATL,SFO] ATL answer [SFO,ATL] SFO answer [SFO] --- started populating from here since it is recursion **/ public List findItinerary(List tickets) { List answer = new ArrayList(); if(tickets== null|| tickets.isEmpty()){ return answer; } Map adjList = new HashMap(); for(List ticket : tickets){ if(!adjList.containsKey(ticket.get(0))){ adjList.put(ticket.get(0),new PriorityQueue()); } adjList.get(ticket.get(0)).offer(ticket.get(1)); } dfs("JFK",adjList,answer); Collections.reverse(answer); return answer; } private void dfs(String node,Map adjList,List answer) { PriorityQueue neighbours = adjList.get(node); if(neighbours != null && !neighbours.isEmpty()){ int size = neighbours.size(); while(!neighbours.isEmpty()){ String neigh = neighbours.poll(); dfs(neigh,adjList,answer); } } answer.add(node); }
@danielpark4204
@danielpark4204 4 жыл бұрын
much better than the leetcode solution.. I attempted by using recursion and loop through adj nodes and tried to keep track of which ones ive visited but keep encountering edge case errors... learned something new with stacks today
@techdose4u
@techdose4u 4 жыл бұрын
Nice :)
@maheshkumartangella5516
@maheshkumartangella5516 2 жыл бұрын
Mad respect for you bro, the way you broke down the problem and simplified it
@techdose4u
@techdose4u 2 жыл бұрын
Thanks 😊
@sarahpark8739
@sarahpark8739 3 жыл бұрын
This video was so helpful! It totally cleared up adjacency lists and stacks for me. Thank you!
@techdose4u
@techdose4u 3 жыл бұрын
Nice ☺️
@srikrishnarohanmadiraju8688
@srikrishnarohanmadiraju8688 3 жыл бұрын
Great explanation Thanks! The process of Adding to stack -> popping the elements -> reversing them before returning answer; instead of that can we use queue, we can reduce the cost of reversing the answer array ?
@TheTushar35
@TheTushar35 4 жыл бұрын
Make July challenge videos also. It would be really helpful to learn from you!Dont stop :)
@techdose4u
@techdose4u 4 жыл бұрын
I will make graph algorithms. Lately, a lot of graph questions are coming on leetcode. It will be better to cover the basics first :)
@nikhilshrivastava8411
@nikhilshrivastava8411 4 жыл бұрын
@@techdose4u bhaiya please make graph videos . U really understands well :)
@Mauglus
@Mauglus 4 жыл бұрын
@@techdose4u If you do explain a graph algorithm, it would be great if you link an example problem on leetcode, so we can practise :)
@techdose4u
@techdose4u 4 жыл бұрын
Yea that's a great idea :)
@jlecampana
@jlecampana Жыл бұрын
This solution is Brutally AWESOME!!!
@UrGuru
@UrGuru 4 жыл бұрын
You are literally god
@techdose4u
@techdose4u 4 жыл бұрын
😅
@b.jayanagavarmavarma191
@b.jayanagavarmavarma191 Жыл бұрын
I injected your technical dose in my brain (techdose) . this feels amazingggggggggg....
@dhruvbhanderi3407
@dhruvbhanderi3407 2 жыл бұрын
if you are feel akward using multiset then just use priority queue
@googleit2490
@googleit2490 Жыл бұрын
Great Explanation Sep'14, 2023 06:39 pm
@muneeswaranbalasubramanian6528
@muneeswaranbalasubramanian6528 3 жыл бұрын
What is the intuition behind using stack? How do we derive the idea of using a stack? Can anyone shed some light here?
@micahsimmons7520
@micahsimmons7520 3 жыл бұрын
It's DFS graph traversal which uses a stack
@electric336
@electric336 4 жыл бұрын
Thanks a lot for your videos, mate. They're very helpful.
@techdose4u
@techdose4u 4 жыл бұрын
Welcome :)
@KevinN44
@KevinN44 3 жыл бұрын
Very helpful explanation. Thanks for even covering the edge cases 👍
@techdose4u
@techdose4u 3 жыл бұрын
Welcome
@enigma2886
@enigma2886 3 жыл бұрын
he makes every problem so simple
@RahulRaj-rq4lh
@RahulRaj-rq4lh 2 жыл бұрын
Wow , learned new things in video thanks
@kunalsoni7681
@kunalsoni7681 4 жыл бұрын
Such a brilliant explanation ☺️😊.. thank you sir..
@techdose4u
@techdose4u 4 жыл бұрын
Welcome
@xingwangcheng4965
@xingwangcheng4965 4 жыл бұрын
Can't be great anymore, genius!
@techdose4u
@techdose4u 4 жыл бұрын
😁
@user-vj4kp7mh4b
@user-vj4kp7mh4b Жыл бұрын
@Techdose explanations are awesome
@SHIVAMRANA-xn8zg
@SHIVAMRANA-xn8zg Ай бұрын
Great Explanation
@mausami16mau
@mausami16mau 4 жыл бұрын
very nicely explained. thanks a ton!
@techdose4u
@techdose4u 4 жыл бұрын
Welcome :)
@devanshuLitoria
@devanshuLitoria 4 жыл бұрын
please include live coding at the end of the video...your explaination are awesome but when i start to code m stuck on who to implement it.
@techdose4u
@techdose4u 4 жыл бұрын
It doesn't make sense to code again because it will take a lot of time to code and if any error comes during recording then that will be painful as well.Having already written code reduces the time of video as well. It's better to just listen to the idea and then you can have a peek at the code and then try implementing it. It should be fun. If you are stuck then have a look at the code again.
@tanujkalra7334
@tanujkalra7334 4 жыл бұрын
absolutely amazing explanation!!
@techdose4u
@techdose4u 4 жыл бұрын
Thanks
@utsavaggrawal2697
@utsavaggrawal2697 Жыл бұрын
how you thought of stack🤔 btw great explanation🙏🙏
@sakshid1724
@sakshid1724 2 жыл бұрын
what a nice explanation
@ShubhamMahawar_Dancer_Actor
@ShubhamMahawar_Dancer_Actor 4 жыл бұрын
such a well and clear approach..nice
@techdose4u
@techdose4u 4 жыл бұрын
Thanks
@sanjanajhawar9982
@sanjanajhawar9982 Жыл бұрын
Awesome !!!
@srisharadhars862
@srisharadhars862 3 жыл бұрын
How did you land on the thought that stack would give the right answer?
@monishnjs
@monishnjs 3 жыл бұрын
Brilliant
@techdose4u
@techdose4u 3 жыл бұрын
Thanks
@ShaliniNegi24
@ShaliniNegi24 4 жыл бұрын
Very beautiful explanation.
@techdose4u
@techdose4u 4 жыл бұрын
Thanks
@ashishkempwad3267
@ashishkempwad3267 4 жыл бұрын
Can we use set in place of multiset?
@AlanSchooll
@AlanSchooll 7 ай бұрын
No you cannot in this problem because there may b multiple flights from one city to anothr city
@purushottamkumar4056
@purushottamkumar4056 3 жыл бұрын
Using that stack was , just 💥
@techdose4u
@techdose4u 3 жыл бұрын
:)
@messi_codes
@messi_codes 2 жыл бұрын
so its a topological sort using dfs?
@sarthakgupta1263
@sarthakgupta1263 4 жыл бұрын
i did it same thing using recursion ....and also used priority queue to keep adjacency list sorted in the map .
@sarthakgupta1263
@sarthakgupta1263 4 жыл бұрын
Sir , which is better acc to you /// multiset or priority queue??
@techdose4u
@techdose4u 4 жыл бұрын
Both have the same complexity. So anything is fine.
@sarthakgupta1263
@sarthakgupta1263 4 жыл бұрын
@@techdose4u ok
@shobhitkumar6820
@shobhitkumar6820 4 жыл бұрын
sir why u have used multiset instead of sets as we cannot have more than 1 ticket between same source and destination or can we have?? i think its not mentioned in the question that's why u have taken multiset na otherwise u would have gone with sets right??
@ShreyaSingh-vr9qi
@ShreyaSingh-vr9qi 4 жыл бұрын
Ho sakta hain, check this test case [["EZE","AXA"],["TIA","ANU"],["ANU","JFK"],["JFK","ANU"],["ANU","EZE"],["TIA","ANU"],["AXA","TIA"],["TIA","JFK"],["ANU","TIA"],["JFK","TIA"]]
@techdose4u
@techdose4u 4 жыл бұрын
Cyclic route will have same destinations multiple times.
@lokeshojha1542
@lokeshojha1542 4 жыл бұрын
Sir plzzz make lectures in which u cover all the topics of data structures.. there are many lectures in youtube but kisi ka code nhi diya hai .... it will be really helpful if we code using your logic
@techdose4u
@techdose4u 4 жыл бұрын
I dint get your question. I think you need me to cover all DS with cod right? So, yes i will make organized lectures from July. Starting from GRAPH then DP and then rest.
@lokeshojha1542
@lokeshojha1542 4 жыл бұрын
@@techdose4u yes sir ... it will be helpful
@UCS_RheaRaviSharma
@UCS_RheaRaviSharma 3 жыл бұрын
We can solve this question without explicitly using stack through DFS. Recursion basically is implemented here with a stack.
@amitkumarmaity1858
@amitkumarmaity1858 Жыл бұрын
Extremely well explained
@Spham99
@Spham99 2 жыл бұрын
I don't think interviewers will let you use the multiset Guava library in the interviews :/
@lingasodanapalli615
@lingasodanapalli615 Жыл бұрын
Great. But It would have been better if you had explained the intution behind taking the stack. You have just simply used it. But the intuition of using stack is not clear.
@abhishek__anand__
@abhishek__anand__ Жыл бұрын
Nice
@huyphihoang7984
@huyphihoang7984 4 жыл бұрын
can you explain why we choose the adjacency list instead of the adjacency matrix and how we can think of using stack?
@harshavardhanmadasi1681
@harshavardhanmadasi1681 2 жыл бұрын
Iam getting TLE with this approach
@rahulagarwal182
@rahulagarwal182 3 жыл бұрын
Smart Guy
@nishanksoni7120
@nishanksoni7120 4 жыл бұрын
Can you please check your playlists once, so many videos are repetitive. Check DP videos - Perfect squares, coin change 2. Please organize the playlists.
@techdose4u
@techdose4u 4 жыл бұрын
Yes will do it. Its youtube error :(
@utkarshsharma357
@utkarshsharma357 25 күн бұрын
Intuition behind using stack, is not explained properly :(
@ksquare1112
@ksquare1112 3 жыл бұрын
Thanks for explanation. Can you let me know the software used in making the screens and video
@SinghFlex
@SinghFlex 4 жыл бұрын
I have a doubt brother ,why multiset and not set? any test case for the explanation??..P.s: Your videos are great.
@techdose4u
@techdose4u 4 жыл бұрын
Correct
@PatelFromPatna
@PatelFromPatna 3 жыл бұрын
but if we are using dfs then even if there is a dead end then it will get back to parent node ....why will the execution stop if dead end is there
@uditagrawal6603
@uditagrawal6603 3 жыл бұрын
+1
@sidharthdhiman4522
@sidharthdhiman4522 3 жыл бұрын
but there was no route from dead end to parent node , there was not any edge from dead end to parent , queesitons says you have travel if there is an edge
@Anythiny
@Anythiny Жыл бұрын
@@sidharthdhiman4522 but this can be implemented using dfs(recursive)
@arjunsabu4927
@arjunsabu4927 2 жыл бұрын
Best explanation !!!
@aashishkohli1198
@aashishkohli1198 3 жыл бұрын
How did u arrive at conclusion to use a stack ?
@chixjain5800
@chixjain5800 4 жыл бұрын
Python Code : from collections import defaultdict matrix = defaultdict(lambda: []) for i in tickets: matrix[i[0]].append(i[1]) for i in matrix: matrix[i].sort(reverse=True) ans = [] def dfs(i): if matrix[i]: v = matrix[i].pop() dfs(v) if matrix[i]: dfs(i) else: ans.append(i) else: ans.append(i) dfs('JFK') print(ans)
@techdose4u
@techdose4u 4 жыл бұрын
👍
@desi_boyz6165
@desi_boyz6165 Ай бұрын
what's the intuition behind this logic?
@shashikantkumar5095
@shashikantkumar5095 3 жыл бұрын
those who don't want to use multi set,We can sort the array in reverse order, as popping the first element is a costly operation
@frostcs
@frostcs 4 жыл бұрын
Code is the gist might have an extra while loop in if condition. Please check.
@techdose4u
@techdose4u 4 жыл бұрын
Yea it was the incorrect version which I was trying. I have updated with the correct version.
@MGtvMusic
@MGtvMusic Жыл бұрын
EYE TEA NERR E ( British. ) -> For fellow coders who might find it difficult to pronounce
@TomJerry-bp9ig
@TomJerry-bp9ig Жыл бұрын
Awesome explanation brother ❤
@ksTales
@ksTales 3 жыл бұрын
Similar to leetcode course schedule ii
@techdose4u
@techdose4u 3 жыл бұрын
:)
@AnshulSharma-vw9wu
@AnshulSharma-vw9wu 4 жыл бұрын
Hi Buddy , it seems like your code is only working for 18 out of 80 test cases One such EXample is [["JFK","KUL"],["JFK","NRT"],["NRT","JFK"]] the correct out put is ["JFK","NRT","JFK","KUL"]
@techdose4u
@techdose4u 4 жыл бұрын
Updated now. That was the wrong version which I shared.
@MagicalCreationAviCreation
@MagicalCreationAviCreation 4 жыл бұрын
hi sir i need one help from you side when i click on solution tab in leet code it shows u have to subscribe sir is it not free, sir whether I have to pay for that ..
@techdose4u
@techdose4u 4 жыл бұрын
Some solutions on leetcode are locked.
@manthankhorwal1477
@manthankhorwal1477 4 жыл бұрын
Please tell me why stack is helping ? i know its giving the correct answer what is intuition behind it so that in future in can think of stack if this kind of problem comes
@techdose4u
@techdose4u 4 жыл бұрын
We are doing DFS. It's tricky though. We need to take care of the condition which I showed you. We travel to a lexically smaller node but it doesn't have the return path. If you take a stack then it will be popped first and hence will be at last in our answer array. That's the idea for using stack.I showed the example in video. I got that after getting WA on the same test case.
@KaranSharmaJi
@KaranSharmaJi 4 жыл бұрын
I have the same question..
@manthankhorwal1477
@manthankhorwal1477 4 жыл бұрын
@@techdose4u i did.everything just stack part didnt came into my mind i got WA for returning component part...thankyou so much
@techdose4u
@techdose4u 4 жыл бұрын
I got stack idea from the WA which I showed in the video. Choosing the wrong path.
@somith16
@somith16 2 жыл бұрын
cant topological sort be used?
@manojboganadham9071
@manojboganadham9071 3 жыл бұрын
What is the intuition behind taking stack DS
@shubhamsapra81
@shubhamsapra81 2 жыл бұрын
topo sort, it is
@rahulgarg7966
@rahulgarg7966 3 жыл бұрын
please provide link of this question.. on gfg.. also.. 😄..
@techdose4u
@techdose4u 3 жыл бұрын
This is from leetcode I guess
@rahulgarg7966
@rahulgarg7966 3 жыл бұрын
@@techdose4u yesss.., i didn't find it on.. gfg.. but thanks for your videos..! i start coding 6 November 2020.. and i score.. 650 .. in 3 months.. 😄
@Vishalraj_1
@Vishalraj_1 4 жыл бұрын
class Solution { public: vector findItinerary(vector& tickets) { for (vectorticket : tickets) targets[ticket[0]].insert(ticket[1]); visit("JFK"); return vector(route.rbegin(), route.rend()); } map targets; vector route; void visit(string airport) { while (targets[airport].size()) { string next = *targets[airport].begin(); targets[airport].erase(targets[airport].begin()); visit(next); } route.push_back(airport); } };
@techdose4u
@techdose4u 4 жыл бұрын
👍
@Ck-ir8ts
@Ck-ir8ts 4 жыл бұрын
Nice one
@techdose4u
@techdose4u 4 жыл бұрын
Thanks :)
@rakeshmanwani4993
@rakeshmanwani4993 4 жыл бұрын
Sir can you please tell us that How we got to know that which data structure should be used for such problems. Because When I try this type of question by my own then it took a long time to get some observation and logic behind it...
@rakeshmanwani4993
@rakeshmanwani4993 4 жыл бұрын
One more thing is how much time it takes you to do this type of questions to you if it is completely new question to you ????
@techdose4u
@techdose4u 4 жыл бұрын
It depends. I got 2 WA before I submitted the correct version. Took 40 mins to solve this. It was slightly tricky. I was using map + vector. Then moved to Map+ multiset. After that I got WA and took that test case and used stack to finally get it correct. So, it was not that simple to solve at one shot because problem was not clear.
@tanyarajhans5560
@tanyarajhans5560 3 жыл бұрын
How to get the intuition of using set?
@meghasharma3092
@meghasharma3092 4 жыл бұрын
could not understand intuition behind using stack
@techdose4u
@techdose4u 4 жыл бұрын
Stack is used for backtracking. So that when we backtrack from a path then we simply pop stack elements to get traversed nodes from fest to source order.
@Karan-vq5vg
@Karan-vq5vg 4 жыл бұрын
The answer is coming out wrong after submission please check the code. Only 18 out of 80 cases are getting passed
@spetsnaz_2
@spetsnaz_2 4 жыл бұрын
Code is fine Karan. I also used same logic
@Karan-vq5vg
@Karan-vq5vg 4 жыл бұрын
@@spetsnaz_2 idk why my test cases are getting failed. I guess i should've tweak the code a bit.
@nikhilshrivastava8411
@nikhilshrivastava8411 4 жыл бұрын
@@Karan-vq5vg Yes 18/80 cases are passing
@AbhishekKumar-hj4qo
@AbhishekKumar-hj4qo 4 жыл бұрын
yes, the code is partially accepted. TECH DOSE Sir please correct it!
@JeanPLugo
@JeanPLugo 4 жыл бұрын
The problem with the code is the second while statement. After you reach an edge with size = 0 you need to pop only that edge and continue with the code. The "while" there was removing every edge as soon as an edge with size == 0 was found.
@Sky-nt1hy
@Sky-nt1hy 3 жыл бұрын
Hi!! thank you for your amazing lecture as always. I'm using c++11 on vscode but for some reason multiset STL doesn't work on my environment. Is there any way to handle with that? Thank you!
@techdose4u
@techdose4u 3 жыл бұрын
Try some other version of CPP like CPP-17 etc.
@udayreddy4475
@udayreddy4475 4 жыл бұрын
You placed N sticks on a straight line. The i th stick is located at position xi and has height hi. There are no two sticks located at the same position. You can push sticks to make them fall to the left or the right side. While falling, a stick can touch its neighbors and make them to fall in the same direction. If a stick at position x with height h is falling to the left, then it makes all the sticks at positions (x - h)....x inclusive fall on to the left. If a stick is falling to the right, it makes all the sticks at positions x...(x + h) inclusive to fall to the right. Your task is to determine the minimal number of sticks you are required to push to make all N sticks fall. ex : 5 sticks 1 2 3 1 6 2 7 1 9 2 ans : 2 note: 1 , 2 indicates a stick is placed at x = 1 with a height h = 2 Sir, can you help me with this.
@BarkaDog
@BarkaDog 4 жыл бұрын
Where did you get the question?
@udayreddy4475
@udayreddy4475 4 жыл бұрын
@@BarkaDog A friend of mine asked me if I can solve this.
@manindersinghsaluja5802
@manindersinghsaluja5802 3 жыл бұрын
Hi, this is an interesting question, first you will have to form 2 graphs assuming only left falls are allowed in first graph and only right falls for the second one. Then, you can find vertices with indegree zero in both graphs, these are vertices that must fall in case only left or right falls are allowed. These vertices will cover the whole distance in which all sticks are placed. Now, keeping the intervals of vertex covers for both graphs side by side, you need to choose minimum number of intervals that cover the whole distance in which the sticks are placed, this can easily be done by starting to pick interval from both ends of distances greedily by choosing larger interval from the ones having same start or end point.
@rahulvutukuri9254
@rahulvutukuri9254 3 жыл бұрын
Sir, you github link is not working
@NikhilSingh-hv9cm
@NikhilSingh-hv9cm 4 жыл бұрын
to select the starting location!!!!!!!?
@nishantboro4728
@nishantboro4728 4 жыл бұрын
I completely lost you on that stack part. You didnt explain the intuition behind it.
@bostonlights2749
@bostonlights2749 3 жыл бұрын
😀
@techdose4u
@techdose4u 3 жыл бұрын
😁
@rajatbudania6181
@rajatbudania6181 4 жыл бұрын
Very well explained :) I tried to do without stack got TLE! class Solution { public: vector findItinerary(vector& tic) { unordered_map m; for(int i=0;i
@spetsnaz_2
@spetsnaz_2 3 жыл бұрын
Code Link : techdose.co.in/reconstruct-itinerary-leetcode-332/
@nikhilshrivastava8411
@nikhilshrivastava8411 4 жыл бұрын
Waiting for your video bhaiya 😅
@techdose4u
@techdose4u 4 жыл бұрын
Nice :)
@duedares
@duedares 3 жыл бұрын
How do you decide that your source will be JFK? I dont think you can generalize this.
@mahesh_kok
@mahesh_kok Жыл бұрын
Python recursive solution: def findItinerary(self, tickets: List[List[str]]) -> List[str]: res = ["JFK"] tickets.sort() adj = collections.defaultdict(list) for src, dst in tickets: adj[src].append(dst) if dst not in adj: adj[dst] = [] output = [] stack = ["JFK"] def dfs(src): while adj[src]: nei = adj[src].pop(0) stack.append(nei) dfs(nei) if stack: stack.pop() output.append(src) dfs("JFK") return output[::-1]
Clone graph | Leetcode #133
13:01
Techdose
Рет қаралды 58 М.
Reconstruct Itinerary - Leetcode 332 - Python
17:38
NeetCode
Рет қаралды 68 М.
ПРИКОЛЫ НАД БРАТОМ #shorts
00:23
Паша Осадчий
Рет қаралды 5 МЛН
How Strong is Tin Foil? 💪
00:26
Preston
Рет қаралды 61 МЛН
Пришёл к другу на ночёвку 😂
01:00
Cadrol&Fatich
Рет қаралды 9 МЛН
330. Patching Array | Greedy | Array | Math | Why not Bitset Trick
23:19
Word Search II | DFS + Map | DFS + TRIE | Leetcode #212
24:49
Google Coding Interview With A Competitive Programmer
54:17
Clément Mihailescu
Рет қаралды 2,5 МЛН
you will never ask about pointers again after watching this video
8:03
Low Level Learning
Рет қаралды 2,2 МЛН
My Brain after 569 Leetcode Problems
7:50
NeetCode
Рет қаралды 2,6 МЛН
Dynamic Programming isn't too hard. You just don't know what it is.
22:31
DecodingIntuition
Рет қаралды 140 М.
Reconstruct Itinerary | LeetCode 332 | C++, Java, Python
35:12
Knowledge Center
Рет қаралды 6 М.
Valid parenthesis string | Leetcode #678
12:41
Techdose
Рет қаралды 52 М.
ПРИКОЛЫ НАД БРАТОМ #shorts
00:23
Паша Осадчий
Рет қаралды 5 МЛН